
DROP TABLE IF EXISTS p30_common.d_scrm_contact;
CREATE TABLE IF NOT EXISTS p30_common.d_scrm_contact (
	 scrm_leads_id  VARCHAR(20) 
	, city_name  VARCHAR(20) 
	, company_name  VARCHAR(50) 
	, email  VARCHAR(50) 
	, email_data_ind  char(1) 
	, email_availability  char(1) 
	, mobile_number  VARCHAR(20) 
	, mobile_phone_data_ind  char(1) 
	, mobile_phone_availability  char(1) 
	, full_name  VARCHAR(20) 
	, prov_name  VARCHAR(20) 
	, create_time  timestamp(0) 
	, wechat_id  VARCHAR(100) 
	, update_time  timestamp(0) 
	, Etl_Batch_No  varchar(50) 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(50) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	,primary key( scrm_leads_id )
);

 COMMENT ON COLUMN p30_common.d_scrm_contact.scrm_leads_id IS 'SCRM线索ID'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.city_name IS '城市'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.company_name IS '公司'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.email IS '邮箱'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.email_data_ind IS '邮箱数据标志'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.email_availability IS '邮箱有效性'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.mobile_number IS '手机号码'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.mobile_phone_data_ind IS '手机号数据标志'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.mobile_phone_availability IS '手机号数据有效性'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.full_name IS '姓名'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.prov_name IS '省份'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.create_time IS '创建时间'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.wechat_id IS '身份-企业微信外部联系人'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.update_time IS '更新时间'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Etl_Batch_No IS '作业批次号'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p30_common.d_scrm_contact.Src_Table IS '来源表'; 

COMMENT ON TABLE p30_common.d_scrm_contact IS 'SCRM联系方式';